package buffers;

public class Buffer<T>
{
	T[] storage;
	int head, tail, size;

	public Buffer(int max)
	{
		storage = (T[])(new Object[max]);
		head = tail = size = 0;
	}

	public Buffer()
	{
		this(10);
	}

	public synchronized void insert(T elem)
	{
		while(size >= storage.length)//se avessi la certezza di essere l'unico ad inserire
																 //potrei usare una condizione non iterata (if)
		{
			//devo aspettare, buffer pieno
			try
			{
				this.wait();
			}
			catch(InterruptedException ie)
			{
				ie.printStackTrace();
			}
		}

		storage[tail] = elem;
		tail = (tail+1)%storage.length;
		size++;
		if(size == 1)
		{
			this.notify();
		}
	}

	public synchronized T remove()
	{
		while(size <= 0)//vedi sopra per la possibilita' di non iterare il test
		{
			//devo aspettare, buffer vuoto
			try
			{
				this.wait();
			}
			catch(InterruptedException ie)
			{
				ie.printStackTrace();
			}
		}

		T retval = storage[head];
		head = (head + 1)%storage.length;
		if(size == storage.length)
		{
			this.notify();
		}
		size--;
		return retval;
	}

	public synchronized int size()
	{
		return size;
	}
}
