package remotizzazione;

import java.io.IOException;
import net.ClientTCP3;

public class RemCalc
{
	ClientTCP3 tc = null;

	public RemCalc() throws IOException
	{
		tc = new ClientTCP3();
		tc.openStreams();
	}

	public double sum(double arg1, double arg2) throws CommException
	{
		double retval = 0;

		Operazione op = new Operazione();
		op.operazione = 0;
		op.d1 = arg1;
		op.d2 = arg2;
		try
		{
			op = (Operazione)tc.submit(op);
		}
		catch(ClassNotFoundException | IOException ioe)
		{
			throw new CommException(ioe.toString());
		}
		retval = op.result;

		return retval;
	}

	public double sub(double arg1, double arg2) throws CommException
	{
		double retval = 0;

		Operazione op = new Operazione();
		op.operazione = 1;
		op.d1 = arg1;
		op.d2 = arg2;
		try
		{
			op = (Operazione)tc.submit(op);
		}
		catch(ClassNotFoundException | IOException ioe)
		{
			throw new CommException(ioe.toString());
		}
		retval = op.result;

		return retval;
	}

	public double mul(double arg1, double arg2) throws CommException
	{
		double retval = 0;

		Operazione op = new Operazione();
		op.operazione = 2;
		op.d1 = arg1;
		op.d2 = arg2;
		try
		{
			op = (Operazione)tc.submit(op);
		}
		catch(ClassNotFoundException | IOException ioe)
		{
			throw new CommException(ioe.toString());
		}
		retval = op.result;

		return retval;
	}

	public double div(double arg1, double arg2) throws CommException
	{
		double retval = 0;

		Operazione op = new Operazione();
		op.operazione = 3;
		op.d1 = arg1;
		op.d2 = arg2;
		try
		{
			op = (Operazione)tc.submit(op);
		}
		catch(ClassNotFoundException | IOException ioe)
		{
			throw new CommException(ioe.toString());
		}
		retval = op.result;

		return retval;
	}

	public static void main(String[] argv) throws IOException, CommException
	{
		RemCalc rc = new RemCalc();
		double d1 = Double.parseDouble(argv[0]);
		double d2 = Double.parseDouble(argv[2]);
		double result = 0;
		if(argv[1].equals("sum"))
		{
			result = rc.sum(d1, d2);
		}
		else if(argv[1].equals("sub"))
		{
			result = rc.sub(d1, d2);
		}
		else if(argv[1].equals("mul"))
		{
			result = rc.mul(d1, d2);
		}
		else if(argv[1].equals("div"))
		{
			result = rc.div(d1, d2);
		}
		System.out.println(result);
	}

}
