package request;

import java.util.concurrent.atomic.AtomicInteger;
import java.util.concurrent.locks.Condition;
import java.util.concurrent.locks.Lock;

public class Key
{
    final private static AtomicInteger counter;
    final private int instanceCount;
    final private Condition c;
    
    public Key(Lock lock)
    {
        instanceCount = counter.getAndIncrement();
        c = lock.newCondition();
    }            
    
    public int getValue()
    {
        return instanceCount;
    }
    
    public synchronized Condition getCondition()
    {
        return c;
    }
    
    static
    {
        counter = new AtomicInteger(Integer.MIN_VALUE);
    }
}